import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
var _excluded = ["option", "notMerge", "lazyUpdate"];
import React from 'react';
import { createRef, forwardRef, Fragment, PureComponent, useEffect, useImperativeHandle, useRef } from 'react';
import * as echarts from 'echarts';
import { defineGetterProperties } from "../../utils";
window.echarts = echarts;

var LCEcharts = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(LCEcharts, _PureComponent);

  function LCEcharts() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    _this.echartsRef = /*#__PURE__*/createRef();
    return _this;
  }

  var _proto = LCEcharts.prototype;

  _proto.componentDidMount = function componentDidMount() {
    // 把操作方法挂载到 class instance 上，可通过 this.$ 调用
    defineGetterProperties(this, [this.echartsRef]);
  };

  _proto.render = function render() {
    var option = this.props.option;

    if (!option) {
      return /*#__PURE__*/React.createElement(Fragment, null);
    }

    return /*#__PURE__*/React.createElement(FCEchartsForward, _extends({}, this.props, {
      ref: this.echartsRef
    }));
  };

  return LCEcharts;
}(PureComponent);

var FCEcharts = function FCEcharts(_ref, ref) {
  var option = _ref.option,
      notMerge = _ref.notMerge,
      lazyUpdate = _ref.lazyUpdate,
      otherProps = _objectWithoutPropertiesLoose(_ref, _excluded);

  var chartRef = useRef();
  var chartInstanceRef = useRef();
  useImperativeHandle(ref, function () {
    return {
      get: function get() {
        return chartInstanceRef.current;
      }
    };
  });
  useEffect(function () {
    if (!option || !chartRef.current) {
      return;
    }

    var renderedInstance = echarts.getInstanceByDom(chartRef.current);
    var chartInstance;

    if (renderedInstance) {
      chartInstance = renderedInstance;
    } else {
      chartInstance = echarts.init(chartRef.current);
    }

    console.log('chartInstance option', option);
    chartInstanceRef.current = chartInstance;
    chartInstance.setOption(option, notMerge, lazyUpdate);
  }, [option, chartRef]);
  return /*#__PURE__*/React.createElement("div", _extends({}, otherProps, {
    ref: chartRef
  }));
};

var FCEchartsForward = /*#__PURE__*/forwardRef(FCEcharts);
export default LCEcharts;