"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var echarts = _interopRequireWildcard(require("echarts"));

var _utils = require("../../utils");

var _excluded = ["option", "notMerge", "lazyUpdate"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

window.echarts = echarts;

var LCEcharts = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(LCEcharts, _PureComponent);

  function LCEcharts() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    _this.echartsRef = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  var _proto = LCEcharts.prototype;

  _proto.componentDidMount = function componentDidMount() {
    // 把操作方法挂载到 class instance 上，可通过 this.$ 调用
    (0, _utils.defineGetterProperties)(this, [this.echartsRef]);
  };

  _proto.render = function render() {
    var option = this.props.option;

    if (!option) {
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null);
    }

    return /*#__PURE__*/_react["default"].createElement(FCEchartsForward, (0, _extends2["default"])({}, this.props, {
      ref: this.echartsRef
    }));
  };

  return LCEcharts;
}(_react.PureComponent);

var FCEcharts = function FCEcharts(_ref, ref) {
  var option = _ref.option,
      notMerge = _ref.notMerge,
      lazyUpdate = _ref.lazyUpdate,
      otherProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var chartRef = (0, _react.useRef)();
  var chartInstanceRef = (0, _react.useRef)();
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      get: function get() {
        return chartInstanceRef.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    if (!option || !chartRef.current) {
      return;
    }

    var renderedInstance = echarts.getInstanceByDom(chartRef.current);
    var chartInstance;

    if (renderedInstance) {
      chartInstance = renderedInstance;
    } else {
      chartInstance = echarts.init(chartRef.current);
    }

    console.log('chartInstance option', option);
    chartInstanceRef.current = chartInstance;
    chartInstance.setOption(option, notMerge, lazyUpdate);
  }, [option, chartRef]);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, otherProps, {
    ref: chartRef
  }));
};

var FCEchartsForward = /*#__PURE__*/(0, _react.forwardRef)(FCEcharts);
var _default = LCEcharts;
exports["default"] = _default;