"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = useAutoResize;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = require("react");

var _utils = require("../utils");

function useAutoResize(ref) {
  var _useState = (0, _react.useState)({
    width: 0,
    height: 0
  }),
      state = _useState[0],
      setState = _useState[1];

  var domRef = (0, _react.useRef)(null);
  var setWH = (0, _react.useCallback)(function () {
    var _ref = domRef.current || {
      clientWidth: 0,
      clientHeight: 0
    },
        clientWidth = _ref.clientWidth,
        clientHeight = _ref.clientHeight;

    setState({
      width: clientWidth,
      height: clientHeight
    });

    if (!domRef.current) {
      console.warn('DataV: Failed to get dom node, component rendering may be abnormal!');
    } else if (!clientWidth || !clientHeight) {
      console.warn('DataV: Component width or height is 0px, rendering abnormality may occur!');
    }
  }, []);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      setWH: setWH
    };
  }, []);
  (0, _react.useEffect)(function () {
    var debounceSetWHFun = (0, _utils.debounce)(setWH, 100);
    debounceSetWHFun();
    var domObserver = (0, _utils.observerDomResize)(domRef.current, debounceSetWHFun);
    window.addEventListener('resize', debounceSetWHFun);
    return function () {
      window.removeEventListener('resize', debounceSetWHFun);

      if (!domObserver) {
        return;
      }

      domObserver.disconnect();
      domObserver.takeRecords();
    };
  }, []);
  return (0, _extends2["default"])({}, state, {
    domRef: domRef,
    setWH: setWH
  });
}